package com.jcg;

import com.google.gson.Gson;
import com.google.gson.internal.LinkedTreeMap;
import com.google.gson.reflect.TypeToken;

import java.io.BufferedReader;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.List;
import java.util.Map;

public class JsonReaderExample {
    private static final Path flightDataJsonFile =
            Paths.get("src/main/resources/flightdata/2016-07-01-1300Z.json");
    @SuppressWarnings("unchecked")
    public static void main(String[] args) {
        Gson gson = new Gson();
        try (BufferedReader reader = Files.newBufferedReader(flightDataJsonFile)) {
            Map<String, Object> map = gson.fromJson(reader, new TypeToken<Map<String, Object>>() {}.getType());
            List<Object> acList = (List<Object>) (map.get("acList"));
            for(Object item : acList) {
                LinkedTreeMap<String, Object> flight = (LinkedTreeMap<String, Object>) item;
                for(Map.Entry<String,Object> entry : flight.entrySet()) {
                    String key = entry.getKey();
                    Object value = entry.getValue();
                    System.out.println(key + " = " + value + ",");
                }
            }
       } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
