package com.jcg;

import com.google.gson.Gson;
import com.google.gson.JsonArray;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.reflect.TypeToken;

import java.io.BufferedReader;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.Map;
import java.util.Set;

public class JsonReaderExampleV2 {
    private static final String flightDataJsonFile = "src/main/resources/flightdata/2016-07-01-1300Z.json";
    private static final Gson gson = new Gson();

    public static void main(String[] args) {
        Gson gson = new Gson();
        try (BufferedReader reader = Files.newBufferedReader(Paths.get(flightDataJsonFile))) {
            Map<String, JsonElement> map = gson.fromJson(reader,
                    new TypeToken<Map<String, JsonElement>>() {
                    }.getType());

            JsonElement acList = (map.get("acList"));
            JsonArray array = acList.getAsJsonArray();

            for (JsonElement item : array) {
                JsonObject itemAsJsonObject = item.getAsJsonObject();
                String id = itemAsJsonObject.get("Id").getAsString();

                StringBuilder recordAsString = new StringBuilder();
                Set<Map.Entry<String, JsonElement>> entries = item.getAsJsonObject().entrySet();
                for (Map.Entry<String, JsonElement> entry : entries) {
                    if (entry.getKey().equals("Id")) {
                        recordAsString.append("{");
                    } else {
                        recordAsString.append(entry.getKey()).append(" : ").append(entry.getValue()).append(",");
                    }
                }
                recordAsString.setCharAt(recordAsString.length() - 1, '}');
                System.out.println(recordAsString.toString());
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
